package com.paymentz;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.http.SslError;
import android.os.Bundle;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.view.View;
import android.webkit.SslErrorHandler;
import android.webkit.WebChromeClient;
import android.webkit.WebResourceError;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ProgressBar;
import android.widget.Toast;

import com.paymentz.checkout_plugin.R;
import com.paymentz.model.EncryptPay;
import com.paymentz.model.RequestParameters;

public class CheckoutActivity extends Activity {
    String params = "";

    //private PassResult listener;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_checkout);
        final ProgressBar progressBar = (ProgressBar) findViewById(R.id.progressBar);
        RequestParameters requestParameters = (RequestParameters) getIntent().getExtras().get("requestParameters");
        WebView webView = (WebView) findViewById(R.id.webView_checkout);
        webView.getSettings();
        webView.setBackground(getResources().getDrawable(R.color.white));
        // webView.setBackgroundColor(R.drawable.background);
        webView.setWebViewClient(new WebViewClient() {

            @Override
            public void onPageStarted(WebView view, String url, Bitmap favicon) {
                super.onPageStarted(view, url, favicon);
                progressBar.setVisibility(View.VISIBLE);
            }

            @Override
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);
                progressBar.setVisibility(View.GONE);
            }

            @Override
            public void onReceivedSslError(WebView view, SslErrorHandler handler, SslError error) {
                Log.e("WEB VIEW ERROR: ", error.toString());
                handler.proceed();
            }

            @Override
            public void onReceivedError(WebView view, WebResourceRequest request, WebResourceError error) {
                super.onReceivedError(view, request, error);
                Log.e("WEB VIEW ERROR: ", error.toString());
            }

            @Override
            public boolean shouldOverrideUrlLoading(WebView view, String url) {
                Log.i("Current URL: ", url);
                return super.shouldOverrideUrlLoading(view, url);
            }
        });

        webView.setWebChromeClient(new WebChromeClient());

        if (requestParameters != null) {

            String dataForMd5Hash = requestParameters.getMemberId() + "|" + requestParameters.getToType()
                    + "|" + requestParameters.getAmount() + "|" + requestParameters.getMerchantTransactionId()
                    + "|" + requestParameters.getMerchantRedirectUrl() + "|" + requestParameters.getMemberKey();


            requestParameters.setChecksum(EncryptPay.generateMD5ChecksumDirectKit(dataForMd5Hash));

            params = "&device=android"
                    + "&memberId=" + requestParameters.getMemberId()
                    + "&totype=" + requestParameters.getToType()
                    + "&mkey=" + requestParameters.getMemberKey()
                    + "&merchantTransactionId=" + requestParameters.getMerchantTransactionId()
                    + "&amount=" + requestParameters.getAmount()
                    + "&TMPL_AMOUNT=" + requestParameters.getTmplAmount()
                    + "&orderDescription=" + requestParameters.getOrderDescription()
                    + "&merchantRedirectUrl=" + requestParameters.getMerchantRedirectUrl()
                    + "&country=" + requestParameters.getCountry()
                    + "&city=" + requestParameters.getCity()
                    + "&state=" + requestParameters.getState()
                    + "&postcode=" + requestParameters.getPostCode()
                    + "&street=" + requestParameters.getStreet()
                    + "&telnocc=" + requestParameters.getTelnocc()
                    + "&phone=" + requestParameters.getPhone()
                    + "&email=" + requestParameters.getEmail()
                    + "&ip=" + requestParameters.getIpAddress()
                    + "&ipaddr=" + requestParameters.getIpAddress()
                    + "&currency=" + requestParameters.getCurrency()
                    + "&TMPL_CURRENCY=" + requestParameters.getTmplCurrency()
                    + "&terminalid=" + requestParameters.getTerminalId()
                    + "&notificationUrl=" + requestParameters.getNotificationUrl()
                    + "&version=" + requestParameters.getVersion()
                    + "&checksum=" + requestParameters.getChecksum()
                    + "&paymentMode=" + requestParameters.getPaymentMode()
                    + "&paymentBrand=" + requestParameters.getPaymentBrand()
                    + "&device=android";

            System.out.println("Parametrs::->" + params);
            if (!params.isEmpty()) {

                webView.postUrl(requestParameters.getHostUrl() + "?", params.getBytes());

                webView.getSettings().setJavaScriptEnabled(true);
                webView.addJavascriptInterface(this, "android");

            } else {
                Toast.makeText(this, "Please, define a valid payment brand", Toast.LENGTH_SHORT).show();
                finish();
            }
        }
    }

    @JavascriptInterface
    public void paymentResultListener(String jsonString) {
        Intent data = new Intent();
        data.putExtra("PAYMENT_RESULT", jsonString);
        this.setResult(-1, data);
        this.finish();
    }

    @Override
    public void onBackPressed() {
        Intent data = new Intent();
        data.putExtra("PAYMENT_RESULT", "{\"resultCode\": \"BACK\",\"message\": \"BACK PRESSED.\"}");
        this.setResult(-1, data);
        this.finish();
        super.onBackPressed();
    }
}