package com.paymentz.model;

import android.app.Activity;
import android.content.Intent;


import com.paymentz.CheckoutActivity;

import java.io.Serializable;
import java.security.MessageDigest;

public class EncryptPay implements Serializable {

    public static final int PAYMENT_REQUEST_CODE = 2568;
    public static final String PAYMENT_RESULT = "PAYMENT_RESULT";

    public static void initPayment(Activity activity, RequestParameters requestParameters) {

        Intent intent = new Intent(activity, CheckoutActivity.class);

        intent.putExtra("requestParameters", requestParameters);
        activity.startActivityForResult(intent, PAYMENT_REQUEST_CODE);
    }

    public static String generateMD5ChecksumDirectKit(String message) {

        try {

            MessageDigest messageDigest = MessageDigest.getInstance("MD5");
            return getString(messageDigest.digest(message.getBytes()));

        } catch (Exception e) {
            e.printStackTrace();
        }

        return message;
    }

    private static String getString(byte buf[]) {
        StringBuffer sb = new StringBuffer(2 * buf.length);
        for (int i = 0; i < buf.length; i++) {
            int h = (buf[i] & 0xf0) >> 4;
            int l = (buf[i] & 0x0f);
            sb.append(new Character((char) ((h > 9) ? 'a' + h - 10 : '0' + h)));
            sb.append(new Character((char) ((l > 9) ? 'a' + l - 10 : '0' + l)));
        }
        return sb.toString();
    }
}

