//
//  StandardCheckout.swift
//  StandardCheckoutKit
//
//  Created by Vinicius on 09/06/17.
//  Copyright © 2017 Paymentz. All rights reserved.
//

import Foundation
import CryptoSwift

public class StandardCheckout:UIViewController {
    
    private var viewController: UIViewController?
    
    public init(viewController: UIViewController) {
        self.viewController = viewController
        super.init(nibName: nil, bundle: nil)
    }
    
    public init() {
        super.init(nibName: nil, bundle: nil)
        self.viewController = self
        
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    public override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    
    public func initPayment(requestParameters: RequestParameters, standardCheckoutDelegate: StandardCheckoutDelegate, secureKey: String){
        
        let standardCheckoutViewController = StandardCheckoutViewController()
        standardCheckoutViewController.secureKey = secureKey
        standardCheckoutViewController.requestParameters = requestParameters
        standardCheckoutViewController.standardCheckoutDelegate = standardCheckoutDelegate
        
        if viewController?.navigationController != nil {
            viewController?.navigationController?.pushViewController(standardCheckoutViewController, animated: true)
        } else{
            viewController?.present(standardCheckoutViewController, animated: true, completion: nil)
        }
    }
    
    static func generateMD5ChecksumDirectKit(directKitStringFormat: String) -> String {
        
        let md5Array = Digest.md5(Array(directKitStringFormat.utf8))
        let md5ArraySize = md5Array.count
        
        let arrayCharSize = md5ArraySize * 2
        
        var arrayChar = [String](repeating: "", count:arrayCharSize)
        
        let alphabet: Array<String> = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"]
        
        for i in 0..<md5ArraySize {
            
            let h = (md5Array[i] & 0xf0) >> 4
            let l = (md5Array[i] & 0x0f)
            
            arrayChar.append(String(h > 9 ? alphabet[Int(h) - 10] : String(h)))
            arrayChar.append(String(l > 9 ? alphabet[Int(l) - 10] : String(l)))
        }
        return arrayChar.joined()
    }
}
